/etc/init.d/bitcoind

The right way to start a Daemon on Debian wheezy is with an init script rather than using /etc/rc.local as we did in the instructions for running bitcoind.

Today I went searching for a good init script for bitcoin and again I found a few that were slightly broken (bealers, bitcointalk, github) and I decided to fix them and post my results here. I also modified similar scripts for dashd, devcoind & namecoind… next comes electrum-server and P2Pool…

If you use this script on your bitcoind server, you may have to change the CHUID to your bitcoind user and group and make sure the DAEMON & BITCOINCLI paths are correct for your installation.
Make the script executable by all and link it in to run at startup with:


sudo chmod +x /etc/init.d/bitcoind
sudo update-rc.d bitcoind defaults

If you followed my earlier instructions, you’ll also have to comment (#) out the line that runs bitcoind in /etc/rc.local.

Here’s my /etc/init.d/bitcoind:


#! /bin/sh
### BEGIN INIT INFO
# Provides:          bitcoind
# Required-Start:    $remote_fs
# Required-Stop:     $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: bitcoind daemon startup script
# Description:       bitcoind daemon startup script
### END INIT INFO


# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Bitcoin Daemon"
NAME=bitcoind
DAEMON=/usr/local/bin/bitcoind
DAEMON_ARGS=-daemon
CLI=/usr/local/bin/bitcoin-cli
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
CHUID=bitnode:bitnode

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null 
      || return 1
   start-stop-daemon --start --quiet --chuid $CHUID --pidfile $PIDFILE --exec $DAEMON -- 
      $DAEMON_ARGS 
      || return 2
}

#
# Function that stops the daemon/service
#
stop_daemon_by_cli () {
    #[ ! -e "$PIDFILE" ] && echo "$DESC not running!" && return 0
    start-stop-daemon --start --chuid $CHUID --exec $CLI -- -rpcwait stop
    return 0
}

do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred
   stop_daemon_by_cli
   start-stop-daemon --stop --quiet --chuid $CHUID --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME

   RETVAL="$?"
   [ "$RETVAL" = 2 ] && return 2
   # Wait for children to finish too if this is a daemon that forks
   # and if the daemon is only ever run from this initscript.
   # If the above conditions are not satisfied then add some other code
   # that waits for the process to drop all resources that could be
   # needed by services started subsequently.  A last resort is to
   # sleep for some time.
   start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
   [ "$?" = 2 ] && return 2
   # Many  daemons don't delete their pidfiles when they exit.
   rm -f $PIDFILE
   return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
   #
   # If the daemon can reload its configuration without
   # restarting (for example, when it is sent a SIGHUP),
   # then implement that here.
   #
   start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
   return 0
}

case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  #reload|force-reload)
   #
   # If do_reload() is not implemented then leave this commented out
   # and leave 'force-reload' as an alias for 'restart'.
   #
   #log_daemon_msg "Reloading $DESC" "$NAME"
   #do_reload
   #log_end_msg $?
   #;;
  restart|force-reload)
   #
   # If the "reload" option is implemented then remove the
   # 'force-reload' alias
   #
   log_daemon_msg "Restarting $DESC" "$NAME"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

exit 0

2 thoughts on “/etc/init.d/bitcoind

  1. Isaac Grover

    Hi, the init script as written insists on pulling the config file as /root/.bitcoin/bitcoin.conf instead of /home/bitnode/.bitcoin/bitcoin.conf . How can this setting be overridden? Thanks in advance. =)

    1. rmwb Post author

      Hi Isaac… It sounds like something else may be going wrong in your instance, (it sounds like maybe your bitcoind is running as the ‘root’ user rather than the ‘bitnode’ user) but if I’m wrong you cold trying editing the DAEMON_ARGS line to add -conf=/home/bitnode/.bitcoin/bitcoin.conf

Leave a Reply